#!/usr/bin/env python

# Base on Conbagui tutorial found here: http://fav.me/dar996a

# It Creates a plastic like with neon center text
# author: Pocholo
# date: 9/26/2020

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder


# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>. 


from gimpfu import *

def pm_billboard_sign():

	#Initiates the temporary state
		
	#Variables
	width = 1600
	height = 1200
	
	#Background
	img = pdb.gimp_image_new(width, height, RGB_IMAGE)
	backLayer = pdb.gimp_layer_new(img, width, height, RGB, "Background", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, backLayer, 0)
	pdb.gimp_layer_add_alpha(backLayer)
	pdb.gimp_drawable_fill(backLayer, FILL_TRANSPARENT)
	pdb.gimp_context_set_gradient("Dusk")	
	pdb.gimp_drawable_edit_gradient_fill(backLayer, 0, 0, TRUE, 3, 0.20, TRUE, 800, 895, 800, 1700)
	pdb.gimp_display_new(img)
	
	#The pole
	poleLayer = pdb.gimp_layer_new(img, width, height, RGB, "Pole", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, poleLayer, 0)
	pdb.gimp_layer_add_alpha(poleLayer)
	pdb.gimp_drawable_fill(poleLayer, FILL_TRANSPARENT)
	pdb.gimp_image_select_rectangle(img, 2, 570, 700, 60, 500)
	pdb.gimp_context_set_foreground((208, 208, 208))
	pdb.gimp_context_set_background((0, 0, 0))
	pdb.gimp_edit_blend(poleLayer, 0, LAYER_MODE_NORMAL, 1, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 605, 924, 628, 924)
	
	#Metal strip shadow
	pdb.gimp_brushes_set_brush("2. Hardness 050")
	pdb.gimp_context_set_brush_size(122)
	pdb.gimp_context_set_brush_default_hardness()
	pdb.gimp_context_set_brush_spacing(0.01)
	pdb.gimp_context_set_brush_force(0.50)
	pdb.gimp_context_set_foreground((0, 0, 0))
	pdb.gimp_paintbrush_default(poleLayer, 2, [600, 800])
		
	#metal strip
	metalstrip = pdb.gimp_layer_new(img, width, height, RGB, "Metal strip", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, metalstrip, 0)
	pdb.gimp_layer_add_alpha(metalstrip)
	pdb.gimp_drawable_fill(metalstrip, FILL_TRANSPARENT)
	pdb.gimp_image_select_rectangle(img, 2, 200, 770, 1200, 14)
	pdb.gimp_context_set_foreground((208, 208, 208))
	pdb.gimp_context_set_background((0, 0, 0))
	pdb.gimp_edit_blend(metalstrip, 0, LAYER_MODE_NORMAL, 1, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 815, 778, 815, 800)
		
	#Screen holder
	screenh = pdb.gimp_layer_new(img, width, height, RGB, "Screen holder", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, screenh, 1)
	pdb.gimp_layer_add_alpha(screenh)
	pdb.gimp_drawable_fill(screenh, FILL_TRANSPARENT)
	pdb.gimp_image_select_rectangle(img, 2, 250, 675, 1100, 85)
	pdb.gimp_context_set_foreground((208, 208, 208))
	pdb.gimp_context_set_background((0, 0, 0))	
	pdb.gimp_edit_blend(screenh, 0, LAYER_MODE_NORMAL, 1, 100, 0, 1, FALSE, TRUE, 3, 0.20, TRUE, 768, 675, 768, 678)
	pdb.gimp_selection_none(img)
	
	#Metal strip holder
	metalh = pdb.gimp_layer_new(img, width, height, RGB, "Metal strip holder", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, metalh, 2)
	pdb.gimp_layer_add_alpha(metalh)
	pdb.gimp_drawable_fill(metalh, FILL_TRANSPARENT)
	pdb.gimp_brushes_set_brush("Bracket")
	pdb.gimp_context_set_brush_size(130)
	pdb.gimp_context_set_brush_default_hardness()
	pdb.gimp_context_set_brush_spacing(0.01)
	pdb.gimp_context_set_brush_force(0.50)
	pdb.gimp_context_set_foreground((89, 89, 89))
	pdb.gimp_paintbrush_default(metalh, 2, [300, 750])
	pdb.gimp_paintbrush_default(metalh, 2, [550, 750])
	pdb.gimp_paintbrush_default(metalh, 2, [800, 750])
	pdb.gimp_paintbrush_default(metalh, 2, [1050, 750])	
	pdb.gimp_paintbrush_default(metalh, 2, [1300, 750])
	
	#Screen 
	screen = pdb.gimp_layer_new(img, width, height, RGB, "Screen", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, screen, 2)
	pdb.gimp_layer_add_alpha(screen)
	pdb.gimp_drawable_fill(screen, FILL_TRANSPARENT)
	pdb.gimp_image_select_rectangle(img, 2, 188, 220, 1200, 500)
	pdb.gimp_context_set_foreground((128, 128, 128))
	pdb.gimp_edit_bucket_fill(screen, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)	
	canvas = pdb.gimp_layer_new(img, width, height, RGB, "Screen canvas", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, canvas, 2)
	pdb.gimp_layer_add_alpha(canvas)
	pdb.gimp_drawable_fill(canvas, FILL_TRANSPARENT)
	pdb.gimp_selection_shrink(img, 30)
	pdb.gimp_context_set_foreground((255, 255, 255))
	pdb.gimp_edit_bucket_fill(canvas, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
	#Inner glow
	pdb.python_layerfx_inner_glow(img, canvas, 
								    (0, 0, 0),   #color
										   85,   #opacity
										    0,   #contou
											0,   #noise
											3,   #mode - multiply 
											1,   #source
											0,   #choke 
										    8,   #size 
										 FALSE)   #merge	
	
	#Frame  
	pdb.gimp_image_select_item(img, 2, screen)
	frame = pdb.gimp_layer_new(img, width, height, RGB, "Frame metal look", 100, LAYER_MODE_OVERLAY)
	pdb.gimp_image_add_layer(img, frame, 2)
	pdb.gimp_layer_add_alpha(frame)
	pdb.gimp_drawable_fill(frame, FILL_TRANSPARENT)
	pdb.gimp_context_set_foreground((200, 200, 200))
	pdb.gimp_context_set_background((94, 94, 94))		
	pdb.gimp_edit_blend(frame, 0, LAYER_MODE_NORMAL, 1, 100, 0, 2, FALSE, TRUE, 3, 0.20, TRUE, 800, 430, 935, 325)
	pdb.gimp_selection_none(img)
	
	#Lights
	lights = pdb.gimp_layer_new(img, width, height, RGB, "Lights", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, lights, 0)
	pdb.gimp_layer_add_alpha(lights)
	pdb.gimp_drawable_fill(lights, FILL_TRANSPARENT)
	pdb.gimp_brushes_set_brush("Bracket")
	pdb.gimp_context_set_brush_size(140)
	pdb.gimp_context_set_brush_angle(180)
	pdb.gimp_context_set_brush_default_hardness()
	pdb.gimp_context_set_brush_spacing(0.01)
	pdb.gimp_context_set_brush_force(0.50)
	pdb.gimp_context_set_foreground((128, 128, 128))
	pdb.gimp_paintbrush_default(lights, 2, [420, 816])
	pdb.gimp_paintbrush_default(lights, 2, [674, 816])
	pdb.gimp_paintbrush_default(lights, 2, [926, 816])
	pdb.gimp_paintbrush_default(lights, 2, [1174, 816])	
	
	#Using map to rotate
	pdb.plug_in_map_object(img, lights, 
									   0,    # Type of mapping (0=plane,1=sphere,2=box,3=cylinder)
                           0.5, 0.5, 2.0,    # viewpoint
                           0.5, 0.5, 0.0,    # object pos
					       1.0, 0.0, 0.0,    # first axis
				           0.0, 1.0, 0.0,    # 2nd axis
		                 0.0, 0.0, -45.0,    # axis rotation
								       0,    # Type of lightsource (0=point,1=directional,2=none)
		                 (255, 255, 255),    # Lightsource color (r,g,b)
				         -0.5, -0.5, 2.0,    # light position
			    	     -1.0, -1.0, 1.0,    # light direction
		    1.00, 0.60, 0.30, 1.50, 50.0,    # material (amb, diff, refl, spec, high)
							        True,    # antialias
								   False,    # tile
								   False,    # new image
							        True,    # transparency
						            0.25,    # Sphere/cylinder radius (only used when maptype=1 or 3)
				           0.5, 0.5, 0.5,    # box size
									1.00,    # unused parameter Cylinder length
									None,    # Box front face (set these to -1 if not used)
									None,    # Box back face
									None,    # Box top face									
									None,    # Box bottom face
									None,    # Box left face
									None,    # Box right face
									None,    # Cylinder top face (unused parameter)
									None)    # Cylinder bottom face (unused parameter)
	
	pdb.gimp_image_select_item(img, 2, lights)
	pdb.gimp_context_set_foreground((190, 190, 190))
	pdb.gimp_context_set_background((40, 40, 40))		
	pdb.gimp_edit_blend(lights, 0, LAYER_MODE_NORMAL, 1, 100, 0, 2, FALSE, TRUE, 3, 0.20, TRUE, 395, 740, 395, 755)
	pdb.gimp_selection_none(img)
	
	#Set gimp to default	
	pdb.gimp_context_set_defaults()
	pdb.gimp_context_set_default_colors()
		
register(
	"pm_billboard_sign",
	"Creates a Billboard Sign",
	"Creates a Billboard Sign",
	"Pocholo",
	"Pocholo",
	"2020",
	"PM Billboard Sign",
	"",
[],
[],
pm_billboard_sign, menu="<Image>/Pocholo-scripts/PM Billboard Sign")
main()						